<?php

class AppKit_LogoutAction extends AppKitBaseAction
{
	/**
	 * Returns the default view if the action does not serve the request
	 * method used.
	 *
	 * @return     mixed <ul>
	 *                     <li>A string containing the view name associated
	 *                     with this action; or</li>
	 *                     <li>An array with two indices: the parent module
	 *                     of the view to be executed and the view to be
	 *                     executed.</li>
	 *                   </ul>
	 */
	public function getDefaultViewName()
	{
		return 'Input';
	}
	
	public function execute(AgaviRequestDataHolder $rd)
	{
		
		if ($rd->getParameter('logout', false) == 1) {
			
			$this->getContext()->getUser()->doLogout();
			
			return 'Success';
			
		}
		
		return 'Input';
	}
	
	public function isSecure() {
		return true;
	}
}

?>