<?php
/**
 * BaseNsmUser
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 * 
 * @property integer $user_id
 * @property integer $user_account
 * @property string $user_name
 * @property string $user_lastname
 * @property string $user_firstname
 * @property string $user_password
 * @property string $user_salt
 * @property string $user_authsrc
 * @property string $user_authid
 * @property string $user_authkey
 * @property string $user_email
 * @property integer $user_disabled
 * @property timestamp $user_created
 * @property timestamp $user_modified
 * @property Doctrine_Collection $NsmPrincipal
 * @property Doctrine_Collection $NsmUserPreference
 * @property Doctrine_Collection $NsmUserRole
 * 
 * @package    ##PACKAGE##
 * @subpackage ##SUBPACKAGE##
 * @author     ##NAME## <##EMAIL##>
 * @version    SVN: $Id: Builder.php 7490 2010-03-29 19:53:27Z jwage $
 */
abstract class BaseNsmUser extends Doctrine_Record
{
	
	public function setTableDefinition()
    {
        $this->setTableName('nsm_user');
        $this->hasColumn('user_id', 'integer', 4, array(
             'type' => 'integer',
             'length' => 4,
             'fixed' => false,
             'unsigned' => false,
             'primary' => true,
             'autoincrement' => true,
             ));
        $this->hasColumn('user_account', 'integer', 4, array(
             'type' => 'integer',
             'length' => 4,
             'fixed' => false,
             'unsigned' => false,
             'primary' => false,
        	 'default' => 0,
             'notnull' => true,
             'autoincrement' => false,
             ));
        $this->hasColumn('user_name', 'string', 127, array(
             'type' => 'string',
             'length' => 127,
             'fixed' => false,
             'unsigned' => false,
             'primary' => false,
             'notnull' => true,
             'autoincrement' => false,
             ));
        $this->hasColumn('user_lastname', 'string', 40, array(
             'type' => 'string',
             'length' => 40,
             'fixed' => false,
             'unsigned' => false,
             'primary' => false,
             'notnull' => true,
             'autoincrement' => false,
             ));
        $this->hasColumn('user_firstname', 'string', 40, array(
             'type' => 'string',
             'length' => 40,
             'fixed' => false,
             'unsigned' => false,
             'primary' => false,
             'notnull' => true,
             'autoincrement' => false,
             ));
        $this->hasColumn('user_password', 'string', 64, array(
             'type' => 'string',
             'length' => 64,
             'fixed' => false,
             'unsigned' => false,
             'primary' => false,
             'notnull' => true,
             'autoincrement' => false,
             ));
        $this->hasColumn('user_salt', 'string', 64, array(
             'type' => 'string',
             'length' => 64,
             'fixed' => false,
             'unsigned' => false,
             'primary' => false,
             'notnull' => true,
             'autoincrement' => false,
             ));
        $this->hasColumn('user_authsrc', 'string', 45, array(
             'type' => 'string',
             'length' => 45,
             'fixed' => false,
             'unsigned' => false,
             'primary' => false,
           	 'default' => 'internal',
             'notnull' => true,
             'autoincrement' => false,
             ));
        $this->hasColumn('user_authid', 'string', 127, array(
             'type' => 'string',
             'length' => 127,
             'fixed' => false,
             'unsigned' => false,
             'primary' => false,
             'notnull' => false,
             'autoincrement' => false,
             ));
        $this->hasColumn('user_authkey', 'string', 64, array(
             'type' => 'string',
             'length' => 64,
             'fixed' => false,
             'unsigned' => false,
             'primary' => false,
             'notnull' => false,
             'autoincrement' => false,
             ));
        $this->hasColumn('user_email', 'string', 40, array(
             'type' => 'string',
             'length' => 40,
             'fixed' => false,
             'unsigned' => false,
             'primary' => false,
             'notnull' => true,
             'autoincrement' => false,
             ));
        $this->hasColumn('user_disabled', 'integer', 1, array(
             'type' => 'integer',
             'length' => 1,
             'fixed' => false,
             'unsigned' => false,
             'primary' => false,
             'default' => '1',
             'notnull' => true,
             'autoincrement' => false,
             ));
        $this->hasColumn('user_created', 'timestamp', null, array(
             'type' => 'timestamp',
             'fixed' => false,
             'unsigned' => false,
             'primary' => false,
             'notnull' => true,
             'autoincrement' => false,
             ));
        $this->hasColumn('user_modified', 'timestamp', null, array(
             'type' => 'timestamp',
             'fixed' => false,
             'unsigned' => false,
             'primary' => false,
             'notnull' => true,
             'autoincrement' => false,
             ));
    	
	//	$this->index('user_unique_idx',array('fields'=>array('user_name')));
		$this->index('user_search_idx',array('fields'=>	array('user_authsrc','user_authid','user_disabled')));
    }
    
    
    public function setUp()
    {
        parent::setUp();

        $this->hasOne('NsmPrincipal', array(
            'local' => 'user_id',
             'foreign' => 'principal_user_id'
        ));

        $this->hasMany('NsmUserPreference', array(
             'local' => 'user_id',
             'foreign' => 'upref_user_id'));

        $this->hasMany('NsmUserRole', array(
             'local' => 'user_id',
             'foreign' => 'usro_user_id'));
    }
    public static function getInitialData() {
		return  array(
			array(
				"user_id"=>1,
				"user_account"=>0,
				"user_name" => 'root',
				"user_firstname" => 'Enoch',
				"user_lastname" => 'Root',
				"user_password" => '42bc5093863dce8c150387a5bb7e3061cf3ea67d2cf1779671e1b0f435e953a1',
				"user_salt" => '0c099ae4627b144f3a7eaa763ba43b10fd5d1caa8738a98f11bb973bebc52ccd',
				"user_authsrc" => 'internal',
//				"user_authid" => '',
				"user_email" => 'root@localhost.local',
				"user_disabled" => 0
			)	
		);
    }
    public static function getPgsqlSequenceOffsets() {
    	return array("nsm_user_user_id_seq" => 2);
    }
}
